/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The require scope
/******/ 	var __webpack_require__ = {};
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "HawkeyeViewModel": function() { return /* reexport */ HawkeyeViewModel; },
  "default": function() { return /* reexport */ Hawkeye; }
});

;// CONCATENATED MODULE: external {"root":"Vue","commonjs":"vue","commonjs2":"vue","amd":"vue"}
var external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject = require("vue");
;// CONCATENATED MODULE: external "@zpc_npm/vue-iclient-common/_utils/gis-utils"
var gis_utils_namespaceObject = require("@zpc_npm/vue-iclient-common/_utils/gis-utils");
;// CONCATENATED MODULE: ./src/leaflet/hawkeye/HawkeyeViewModel.js
/**
 * Author: ZL
 * Data: 2022.9.21
 * Description: 鹰眼组件逻辑类.
 */

class HawkeyeViewModel extends L.Evented {
  /**
   * @param {Object} props 组件外部传入参数对象
   * @event webMapMounted 获取到地图，并初始化鹰眼后执行的事件
   */
  constructor(props) {
    super();
    /**
     * 绑定地图的target
     * @private
     */

    this._mapTarget = props.mapTarget;
    /**
     * 组件外部传入参数对象
     * @type {Object}
     * @private
     */

    this._props = props;
    this._loaded = this._loaded.bind(this);
  }
  /**
   * 初始化
   */


  init() {
    gis_utils_namespaceObject.utils.getWebMap(this._mapTarget, this._loaded);
  }
  /**
   * 获取地图后的回调函数
   * @param {MapViewViewModel} webmap 地图对象
   * @fires webMapMounted
   * @private
   */


  _loaded(webmap) {
    this._webMap = webmap;
    this.start();
    this.fire("webMapMounted");
  }
  /**
   * 初始化鹰眼
   */


  start() {
    let params = {};

    for (let item in this._props) {
      if (this._props[item] !== null && this._props[item] !== undefined && item !== "layerData") {
        params[item] = this._props[item];
      }
    } // 鹰眼的第三方库的position和kq组件的大小写不一样 格式化成一样的


    if (params["position"]) {
      params["position"] = params["position"].toLowerCase();
    }

    this._webMap.mapControl.startMiniMap(this._props.layerData, params);
  }
  /**
   * 给鹰眼注册事件
   * @param {string} type
   * @param {Function} fn
   */


  bindEvents(type, fn) {
    this._webMap.mapControl.miniMap.on(type, fn);
  }
  /**
   * 销毁
   */


  destroy() {
    this.off();

    this._webMap.mapControl.miniMap.off();
  }

}
;// CONCATENATED MODULE: ./node_modules/babel-loader/lib/index.js!./node_modules/vue-loader/dist/index.js??ruleSet[0]!./src/leaflet/hawkeye/Hawkeye.vue?vue&type=script&setup=true&lang=js


const __default__ = {
  name: "Kq2dHawkeye"
};
/* harmony default export */ var Hawkeyevue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(__default__, {
  props: {
    mapTarget: String,
    // 图层数据
    layerData: Array,
    // 标准 Leaflet.Control 位置参数，与所有其他控件一样使用。默认为“bottomRight”。
    position: {
      type: String,
      default: "bottomRight"
    },
    // 小地图的宽度，以像素为单位。默认为 150。
    width: {
      type: Number,
      default: 150
    },
    // 小地图的高度（以像素为单位）。默认为 150。
    height: {
      type: Number,
      default: 150
    },
    // 折叠时切换标记和小地图的宽度，以像素为单位。默认为 19。
    collapsedWidth: {
      type: Number,
      default: 19
    },
    // 折叠时切换标记和小地图的高度，以像素为单位。默认为 19。
    collapsedHeight: {
      type: Number,
      default: 19
    },
    // 与主地图缩放相比，应用于小地图缩放的偏移量。可以是正数或负数，默认为 -5。
    zoomLevelOffset: {
      type: Number,
      default: -5
    },
    // 覆盖偏移量以将固定缩放级别应用于小地图，而不管主地图缩放。如果改为使用未设置的 zoomLevelOffset，请将其设置为任何有效的缩放级别。
    zoomLevelFixed: {
      type: Boolean,
      default: false
    },
    // 无论主地图的视图/位置如何，都将固定位置应用于小地图。防止平移小地图，但允许缩放（在小地图和主地图中）。如果小地图被缩放，它将始终围绕 centerFixed 点进行缩放。您可以传入一个与 LatLng 等效的对象。默认为false。
    centerFixed: {
      type: Boolean,
      default: false
    },
    // 设置小地图是否应该有动画缩放。 （会导致它在主地图移动后稍微滞后。）默认为 false。
    zoomAnimation: {
      type: Boolean,
      default: false
    },
    // 设置小地图是否应该有一个按钮来最小化它。默认为false。
    toggleDisplay: {
      type: Boolean,
      default: false
    },
    // 设置如果父地图边界不适合小地图边界，小地图是否应自动隐藏。当设置了 'zoomLevelFixed' 时特别有用。
    autoToggleDisplay: {
      type: Boolean,
      default: false
    },
    // 设置小地图是否应该从最小化位置开始。
    minimized: {
      type: Boolean,
      default: false
    },
    // 通过传入一个 Path.Options 对象来设置瞄准矩形的样式。 （Clickable 将始终被覆盖并设置为 false。）
    aimingRectOptions: {
      type: Object,
      default: null
    },
    // 通过传入一个 Path.Options 对象来设置瞄准阴影矩形的样式。 （Clickable 将始终被覆盖并设置为 false。）
    shadowRectOptions: {
      type: Object,
      default: null
    },
    // 覆盖允许翻译的默认字符串。请参阅下面的可用字符串和 example/example_i18n.html 以获取示例{ hideText: '',  showText: ''}
    strings: {
      type: Object,
      default: null
    },
    // 设置 MiniMap 地图的 Leaflet 选项。它不会覆盖 MiniMap 默认地图选项，而是扩展它们
    mapOptions: {
      type: Object,
      default: null
    }
  },
  emits: ["toggle", "minimize", "restore"],

  setup(__props, {
    emit
  }) {
    const props = __props;
    let viewModel;
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onMounted)(() => {
      viewModel = new HawkeyeViewModel(props);
      viewModel.on("webMapMounted", () => {
        viewModel.bindEvents("toggle", toggle);
        viewModel.bindEvents("minimize", minimize);
        viewModel.bindEvents("restore", restore);
      });
      viewModel.init();
    });
    (0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_namespaceObject.onBeforeUnmount)(() => {
      viewModel.destroy();
      viewModel = null;
    });
    /**
     * 切换
     */

    function toggle() {
      emit("toggle");
    }
    /**
     * 做小化
     */


    function minimize() {
      emit("minimize");
    }
    /**
     * 还原
     */


    function restore() {
      emit("restore");
    }

    return (_ctx, _cache) => {
      return null;
    };
  }

}));
;// CONCATENATED MODULE: ./src/leaflet/hawkeye/Hawkeye.vue?vue&type=script&setup=true&lang=js
 
;// CONCATENATED MODULE: ./src/leaflet/hawkeye/Hawkeye.vue



const __exports__ = Hawkeyevue_type_script_setup_true_lang_js;

/* harmony default export */ var Hawkeye = (__exports__);
;// CONCATENATED MODULE: external "@zpc_npm/vue-iclient-common/init.js"
var init_js_namespaceObject = require("@zpc_npm/vue-iclient-common/init.js");
var init_js_default = /*#__PURE__*/__webpack_require__.n(init_js_namespaceObject);
;// CONCATENATED MODULE: ./src/leaflet/hawkeye/index.js




Hawkeye.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Hawkeye.name, Hawkeye);
};


module.exports = __webpack_exports__;
/******/ })()
;